# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetAilySessionRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.aily_session_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetAilySessionRequestBuilder":
        return GetAilySessionRequestBuilder()


class GetAilySessionRequestBuilder(object):

    def __init__(self) -> None:
        get_aily_session_request = GetAilySessionRequest()
        get_aily_session_request.http_method = HttpMethod.GET
        get_aily_session_request.uri = "/open-apis/aily/v1/sessions/:aily_session_id"
        get_aily_session_request.token_types = {AccessTokenType.USER, AccessTokenType.TENANT}
        self._get_aily_session_request: GetAilySessionRequest = get_aily_session_request

    def aily_session_id(self, aily_session_id: str) -> "GetAilySessionRequestBuilder":
        self._get_aily_session_request.aily_session_id = aily_session_id
        self._get_aily_session_request.paths["aily_session_id"] = str(aily_session_id)
        return self

    def build(self) -> GetAilySessionRequest:
        return self._get_aily_session_request
