# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.apply_scope_request import ApplyScopeRequest
from ..model.apply_scope_response import ApplyScopeResponse
from ..model.list_scope_request import ListScopeRequest
from ..model.list_scope_response import ListScopeResponse


class Scope(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def apply(self, request: ApplyScopeRequest, option: Optional[RequestOption] = None) -> ApplyScopeResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ApplyScopeResponse = JSON.unmarshal(str(resp.content, UTF_8), ApplyScopeResponse)
        response.raw = resp

        return response

    async def aapply(self, request: ApplyScopeRequest, option: Optional[RequestOption] = None) -> ApplyScopeResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ApplyScopeResponse = JSON.unmarshal(str(resp.content, UTF_8), ApplyScopeResponse)
        response.raw = resp

        return response

    def list(self, request: ListScopeRequest, option: Optional[RequestOption] = None) -> ListScopeResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListScopeResponse = JSON.unmarshal(str(resp.content, UTF_8), ListScopeResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListScopeRequest, option: Optional[RequestOption] = None) -> ListScopeResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListScopeResponse = JSON.unmarshal(str(resp.content, UTF_8), ListScopeResponse)
        response.raw = resp

        return response
