# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .upload_report_archive_rule_request_body import UploadReportArchiveRuleRequestBody


class UploadReportArchiveRuleRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.employee_type: Optional[str] = None
        self.request_body: Optional[UploadReportArchiveRuleRequestBody] = None

    @staticmethod
    def builder() -> "UploadReportArchiveRuleRequestBuilder":
        return UploadReportArchiveRuleRequestBuilder()


class UploadReportArchiveRuleRequestBuilder(object):

    def __init__(self) -> None:
        upload_report_archive_rule_request = UploadReportArchiveRuleRequest()
        upload_report_archive_rule_request.http_method = HttpMethod.POST
        upload_report_archive_rule_request.uri = "/open-apis/attendance/v1/archive_rule/upload_report"
        upload_report_archive_rule_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._upload_report_archive_rule_request: UploadReportArchiveRuleRequest = upload_report_archive_rule_request

    def employee_type(self, employee_type: str) -> "UploadReportArchiveRuleRequestBuilder":
        self._upload_report_archive_rule_request.employee_type = employee_type
        self._upload_report_archive_rule_request.add_query("employee_type", employee_type)
        return self

    def request_body(self, request_body: UploadReportArchiveRuleRequestBody) -> "UploadReportArchiveRuleRequestBuilder":
        self._upload_report_archive_rule_request.request_body = request_body
        self._upload_report_archive_rule_request.body = request_body
        return self

    def build(self) -> UploadReportArchiveRuleRequest:
        return self._upload_report_archive_rule_request
