# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListChangeReasonRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListChangeReasonRequestBuilder":
        return ListChangeReasonRequestBuilder()


class ListChangeReasonRequestBuilder(object):

    def __init__(self) -> None:
        list_change_reason_request = ListChangeReasonRequest()
        list_change_reason_request.http_method = HttpMethod.GET
        list_change_reason_request.uri = "/open-apis/compensation/v1/change_reasons"
        list_change_reason_request.token_types = {AccessTokenType.TENANT}
        self._list_change_reason_request: ListChangeReasonRequest = list_change_reason_request

    def page_size(self, page_size: int) -> "ListChangeReasonRequestBuilder":
        self._list_change_reason_request.page_size = page_size
        self._list_change_reason_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListChangeReasonRequestBuilder":
        self._list_change_reason_request.page_token = page_token
        self._list_change_reason_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListChangeReasonRequest:
        return self._list_change_reason_request
