# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListItemCategoryRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListItemCategoryRequestBuilder":
        return ListItemCategoryRequestBuilder()


class ListItemCategoryRequestBuilder(object):

    def __init__(self) -> None:
        list_item_category_request = ListItemCategoryRequest()
        list_item_category_request.http_method = HttpMethod.GET
        list_item_category_request.uri = "/open-apis/compensation/v1/item_categories"
        list_item_category_request.token_types = {AccessTokenType.TENANT}
        self._list_item_category_request: ListItemCategoryRequest = list_item_category_request

    def page_size(self, page_size: int) -> "ListItemCategoryRequestBuilder":
        self._list_item_category_request.page_size = page_size
        self._list_item_category_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListItemCategoryRequestBuilder":
        self._list_item_category_request.page_token = page_token
        self._list_item_category_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListItemCategoryRequest:
        return self._list_item_category_request
