# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListPlanRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListPlanRequestBuilder":
        return ListPlanRequestBuilder()


class ListPlanRequestBuilder(object):

    def __init__(self) -> None:
        list_plan_request = ListPlanRequest()
        list_plan_request.http_method = HttpMethod.GET
        list_plan_request.uri = "/open-apis/compensation/v1/plans"
        list_plan_request.token_types = {AccessTokenType.TENANT}
        self._list_plan_request: ListPlanRequest = list_plan_request

    def page_size(self, page_size: int) -> "ListPlanRequestBuilder":
        self._list_plan_request.page_size = page_size
        self._list_plan_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListPlanRequestBuilder":
        self._list_plan_request.page_token = page_token
        self._list_plan_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListPlanRequest:
        return self._list_plan_request
