# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .group import Group


class CreateGroupRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[Group] = None

    @staticmethod
    def builder() -> "CreateGroupRequestBuilder":
        return CreateGroupRequestBuilder()


class CreateGroupRequestBuilder(object):

    def __init__(self) -> None:
        create_group_request = CreateGroupRequest()
        create_group_request.http_method = HttpMethod.POST
        create_group_request.uri = "/open-apis/contact/v3/group"
        create_group_request.token_types = {AccessTokenType.TENANT}
        self._create_group_request: CreateGroupRequest = create_group_request

    def user_id_type(self, user_id_type: str) -> "CreateGroupRequestBuilder":
        self._create_group_request.user_id_type = user_id_type
        self._create_group_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "CreateGroupRequestBuilder":
        self._create_group_request.department_id_type = department_id_type
        self._create_group_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self, request_body: Group) -> "CreateGroupRequestBuilder":
        self._create_group_request.request_body = request_body
        self._create_group_request.body = request_body
        return self

    def build(self) -> CreateGroupRequest:
        return self._create_group_request
