# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.construct import init
from .name_for_update import NameForUpdate
from .phone_for_update import PhoneForUpdate
from .email_for_update import EmailForUpdate
from .resident_tax_for_update import ResidentTaxForUpdate
from .dependent_for_update import DependentForUpdate
from .bank_account_for_update import BankAccountForUpdate
from .national_id_for_update import NationalIdForUpdate
from .personal_profile_for_update import PersonalProfileForUpdate
from .emergency_contact_for_update import EmergencyContactForUpdate
from .address_for_update import AddressForUpdate
from .object_field_data import ObjectFieldData


class BasicInfoUpdate(object):
    _types = {
        "names": List[NameForUpdate],
        "phones": List[PhoneForUpdate],
        "emails": List[EmailForUpdate],
        "nationality_v2_id": str,
        "additional_nationality_id_list": List[str],
        "resident_tax_list": List[ResidentTaxForUpdate],
        "born_country_region": str,
        "is_disabled": bool,
        "disable_card_number": str,
        "is_old_alone": bool,
        "is_martyr_family": bool,
        "martyr_card_number": str,
        "dependent_list": List[DependentForUpdate],
        "religion": str,
        "bank_account_list": List[BankAccountForUpdate],
        "national_id_list": List[NationalIdForUpdate],
        "personal_profile_list": List[PersonalProfileForUpdate],
        "emergency_contact_list": List[EmergencyContactForUpdate],
        "address_list": List[AddressForUpdate],
        "marital_status": str,
        "ethnicity_race": str,
        "custom_fields": List[ObjectFieldData],
        "native_region": str,
        "hukou_type": str,
        "hukou_location": str,
    }

    def __init__(self, d=None):
        self.names: Optional[List[NameForUpdate]] = None
        self.phones: Optional[List[PhoneForUpdate]] = None
        self.emails: Optional[List[EmailForUpdate]] = None
        self.nationality_v2_id: Optional[str] = None
        self.additional_nationality_id_list: Optional[List[str]] = None
        self.resident_tax_list: Optional[List[ResidentTaxForUpdate]] = None
        self.born_country_region: Optional[str] = None
        self.is_disabled: Optional[bool] = None
        self.disable_card_number: Optional[str] = None
        self.is_old_alone: Optional[bool] = None
        self.is_martyr_family: Optional[bool] = None
        self.martyr_card_number: Optional[str] = None
        self.dependent_list: Optional[List[DependentForUpdate]] = None
        self.religion: Optional[str] = None
        self.bank_account_list: Optional[List[BankAccountForUpdate]] = None
        self.national_id_list: Optional[List[NationalIdForUpdate]] = None
        self.personal_profile_list: Optional[List[PersonalProfileForUpdate]] = None
        self.emergency_contact_list: Optional[List[EmergencyContactForUpdate]] = None
        self.address_list: Optional[List[AddressForUpdate]] = None
        self.marital_status: Optional[str] = None
        self.ethnicity_race: Optional[str] = None
        self.custom_fields: Optional[List[ObjectFieldData]] = None
        self.native_region: Optional[str] = None
        self.hukou_type: Optional[str] = None
        self.hukou_location: Optional[str] = None
        init(self, d, self._types)

    @staticmethod
    def builder() -> "BasicInfoUpdateBuilder":
        return BasicInfoUpdateBuilder()


class BasicInfoUpdateBuilder(object):
    def __init__(self) -> None:
        self._basic_info_update = BasicInfoUpdate()

    def names(self, names: List[NameForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.names = names
        return self

    def phones(self, phones: List[PhoneForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.phones = phones
        return self

    def emails(self, emails: List[EmailForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.emails = emails
        return self

    def nationality_v2_id(self, nationality_v2_id: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.nationality_v2_id = nationality_v2_id
        return self

    def additional_nationality_id_list(self, additional_nationality_id_list: List[str]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.additional_nationality_id_list = additional_nationality_id_list
        return self

    def resident_tax_list(self, resident_tax_list: List[ResidentTaxForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.resident_tax_list = resident_tax_list
        return self

    def born_country_region(self, born_country_region: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.born_country_region = born_country_region
        return self

    def is_disabled(self, is_disabled: bool) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.is_disabled = is_disabled
        return self

    def disable_card_number(self, disable_card_number: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.disable_card_number = disable_card_number
        return self

    def is_old_alone(self, is_old_alone: bool) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.is_old_alone = is_old_alone
        return self

    def is_martyr_family(self, is_martyr_family: bool) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.is_martyr_family = is_martyr_family
        return self

    def martyr_card_number(self, martyr_card_number: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.martyr_card_number = martyr_card_number
        return self

    def dependent_list(self, dependent_list: List[DependentForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.dependent_list = dependent_list
        return self

    def religion(self, religion: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.religion = religion
        return self

    def bank_account_list(self, bank_account_list: List[BankAccountForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.bank_account_list = bank_account_list
        return self

    def national_id_list(self, national_id_list: List[NationalIdForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.national_id_list = national_id_list
        return self

    def personal_profile_list(self, personal_profile_list: List[PersonalProfileForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.personal_profile_list = personal_profile_list
        return self

    def emergency_contact_list(self,
                               emergency_contact_list: List[EmergencyContactForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.emergency_contact_list = emergency_contact_list
        return self

    def address_list(self, address_list: List[AddressForUpdate]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.address_list = address_list
        return self

    def marital_status(self, marital_status: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.marital_status = marital_status
        return self

    def ethnicity_race(self, ethnicity_race: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.ethnicity_race = ethnicity_race
        return self

    def custom_fields(self, custom_fields: List[ObjectFieldData]) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.custom_fields = custom_fields
        return self

    def native_region(self, native_region: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.native_region = native_region
        return self

    def hukou_type(self, hukou_type: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.hukou_type = hukou_type
        return self

    def hukou_location(self, hukou_location: str) -> "BasicInfoUpdateBuilder":
        self._basic_info_update.hukou_location = hukou_location
        return self

    def build(self) -> "BasicInfoUpdate":
        return self._basic_info_update
