# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.construct import init
from .form_field_variable_string_value import FormFieldVariableStringValue
from .form_field_variable_string_value import FormFieldVariableStringValue
from .form_field_variable_number_value import FormFieldVariableNumberValue
from .form_field_variable_string_value import FormFieldVariableStringValue
from .form_field_variable_number_value import FormFieldVariableNumberValue
from .form_field_variable_string_value import FormFieldVariableStringValue
from .form_field_variable_null_value import FormFieldVariableNullValue
from .form_field_variable_bool_value import FormFieldVariableBoolValue
from .form_field_variable_string_value import FormFieldVariableStringValue
from .form_field_variable_i18n_value import FormFieldVariableI18nValue
from .form_field_variable_string_value import FormFieldVariableStringValue


class FormVariableValueInfo(object):
    _types = {
        "text_value": FormFieldVariableStringValue,
        "number_value": FormFieldVariableStringValue,
        "date_value": FormFieldVariableNumberValue,
        "employment_value": FormFieldVariableStringValue,
        "date_time_value": FormFieldVariableNumberValue,
        "enum_value": FormFieldVariableStringValue,
        "null_value": FormFieldVariableNullValue,
        "bool_value": FormFieldVariableBoolValue,
        "department_value": FormFieldVariableStringValue,
        "i18n_value": FormFieldVariableI18nValue,
        "object_value": FormFieldVariableStringValue,
    }

    def __init__(self, d=None):
        self.text_value: Optional[FormFieldVariableStringValue] = None
        self.number_value: Optional[FormFieldVariableStringValue] = None
        self.date_value: Optional[FormFieldVariableNumberValue] = None
        self.employment_value: Optional[FormFieldVariableStringValue] = None
        self.date_time_value: Optional[FormFieldVariableNumberValue] = None
        self.enum_value: Optional[FormFieldVariableStringValue] = None
        self.null_value: Optional[FormFieldVariableNullValue] = None
        self.bool_value: Optional[FormFieldVariableBoolValue] = None
        self.department_value: Optional[FormFieldVariableStringValue] = None
        self.i18n_value: Optional[FormFieldVariableI18nValue] = None
        self.object_value: Optional[FormFieldVariableStringValue] = None
        init(self, d, self._types)

    @staticmethod
    def builder() -> "FormVariableValueInfoBuilder":
        return FormVariableValueInfoBuilder()


class FormVariableValueInfoBuilder(object):
    def __init__(self) -> None:
        self._form_variable_value_info = FormVariableValueInfo()

    def text_value(self, text_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.text_value = text_value
        return self

    def number_value(self, number_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.number_value = number_value
        return self

    def date_value(self, date_value: FormFieldVariableNumberValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.date_value = date_value
        return self

    def employment_value(self, employment_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.employment_value = employment_value
        return self

    def date_time_value(self, date_time_value: FormFieldVariableNumberValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.date_time_value = date_time_value
        return self

    def enum_value(self, enum_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.enum_value = enum_value
        return self

    def null_value(self, null_value: FormFieldVariableNullValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.null_value = null_value
        return self

    def bool_value(self, bool_value: FormFieldVariableBoolValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.bool_value = bool_value
        return self

    def department_value(self, department_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.department_value = department_value
        return self

    def i18n_value(self, i18n_value: FormFieldVariableI18nValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.i18n_value = i18n_value
        return self

    def object_value(self, object_value: FormFieldVariableStringValue) -> "FormVariableValueInfoBuilder":
        self._form_variable_value_info.object_value = object_value
        return self

    def build(self) -> "FormVariableValueInfo":
        return self._form_variable_value_info
