# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetProcessFormVariableDataRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.process_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetProcessFormVariableDataRequestBuilder":
        return GetProcessFormVariableDataRequestBuilder()


class GetProcessFormVariableDataRequestBuilder(object):

    def __init__(self) -> None:
        get_process_form_variable_data_request = GetProcessFormVariableDataRequest()
        get_process_form_variable_data_request.http_method = HttpMethod.GET
        get_process_form_variable_data_request.uri = "/open-apis/corehr/v2/processes/:process_id/form_variable_data"
        get_process_form_variable_data_request.token_types = {AccessTokenType.TENANT}
        self._get_process_form_variable_data_request: GetProcessFormVariableDataRequest = get_process_form_variable_data_request

    def user_id_type(self, user_id_type: str) -> "GetProcessFormVariableDataRequestBuilder":
        self._get_process_form_variable_data_request.user_id_type = user_id_type
        self._get_process_form_variable_data_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "GetProcessFormVariableDataRequestBuilder":
        self._get_process_form_variable_data_request.department_id_type = department_id_type
        self._get_process_form_variable_data_request.add_query("department_id_type", department_id_type)
        return self

    def process_id(self, process_id: str) -> "GetProcessFormVariableDataRequestBuilder":
        self._get_process_form_variable_data_request.process_id = process_id
        self._get_process_form_variable_data_request.paths["process_id"] = str(process_id)
        return self

    def build(self) -> GetProcessFormVariableDataRequest:
        return self._get_process_form_variable_data_request
