# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .patch_cost_center_request_body import PatchCostCenterRequestBody


class PatchCostCenterRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.cost_center_id: Optional[str] = None
        self.request_body: Optional[PatchCostCenterRequestBody] = None

    @staticmethod
    def builder() -> "PatchCostCenterRequestBuilder":
        return PatchCostCenterRequestBuilder()


class PatchCostCenterRequestBuilder(object):

    def __init__(self) -> None:
        patch_cost_center_request = PatchCostCenterRequest()
        patch_cost_center_request.http_method = HttpMethod.PATCH
        patch_cost_center_request.uri = "/open-apis/corehr/v2/cost_centers/:cost_center_id"
        patch_cost_center_request.token_types = {AccessTokenType.TENANT}
        self._patch_cost_center_request: PatchCostCenterRequest = patch_cost_center_request

    def user_id_type(self, user_id_type: str) -> "PatchCostCenterRequestBuilder":
        self._patch_cost_center_request.user_id_type = user_id_type
        self._patch_cost_center_request.add_query("user_id_type", user_id_type)
        return self

    def cost_center_id(self, cost_center_id: str) -> "PatchCostCenterRequestBuilder":
        self._patch_cost_center_request.cost_center_id = cost_center_id
        self._patch_cost_center_request.paths["cost_center_id"] = str(cost_center_id)
        return self

    def request_body(self, request_body: PatchCostCenterRequestBody) -> "PatchCostCenterRequestBuilder":
        self._patch_cost_center_request.request_body = request_body
        self._patch_cost_center_request.body = request_body
        return self

    def build(self) -> PatchCostCenterRequest:
        return self._patch_cost_center_request
