# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_multi_timeline_department_request_body import QueryMultiTimelineDepartmentRequestBody


class QueryMultiTimelineDepartmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[QueryMultiTimelineDepartmentRequestBody] = None

    @staticmethod
    def builder() -> "QueryMultiTimelineDepartmentRequestBuilder":
        return QueryMultiTimelineDepartmentRequestBuilder()


class QueryMultiTimelineDepartmentRequestBuilder(object):

    def __init__(self) -> None:
        query_multi_timeline_department_request = QueryMultiTimelineDepartmentRequest()
        query_multi_timeline_department_request.http_method = HttpMethod.POST
        query_multi_timeline_department_request.uri = "/open-apis/corehr/v2/departments/query_multi_timeline"
        query_multi_timeline_department_request.token_types = {AccessTokenType.TENANT}
        self._query_multi_timeline_department_request: QueryMultiTimelineDepartmentRequest = query_multi_timeline_department_request

    def page_size(self, page_size: int) -> "QueryMultiTimelineDepartmentRequestBuilder":
        self._query_multi_timeline_department_request.page_size = page_size
        self._query_multi_timeline_department_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "QueryMultiTimelineDepartmentRequestBuilder":
        self._query_multi_timeline_department_request.page_token = page_token
        self._query_multi_timeline_department_request.add_query("page_token", page_token)
        return self

    def user_id_type(self, user_id_type: str) -> "QueryMultiTimelineDepartmentRequestBuilder":
        self._query_multi_timeline_department_request.user_id_type = user_id_type
        self._query_multi_timeline_department_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "QueryMultiTimelineDepartmentRequestBuilder":
        self._query_multi_timeline_department_request.department_id_type = department_id_type
        self._query_multi_timeline_department_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self,
                     request_body: QueryMultiTimelineDepartmentRequestBody) -> "QueryMultiTimelineDepartmentRequestBuilder":
        self._query_multi_timeline_department_request.request_body = request_body
        self._query_multi_timeline_department_request.body = request_body
        return self

    def build(self) -> QueryMultiTimelineDepartmentRequest:
        return self._query_multi_timeline_department_request
