# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_timeline_department_request_body import QueryTimelineDepartmentRequestBody


class QueryTimelineDepartmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[QueryTimelineDepartmentRequestBody] = None

    @staticmethod
    def builder() -> "QueryTimelineDepartmentRequestBuilder":
        return QueryTimelineDepartmentRequestBuilder()


class QueryTimelineDepartmentRequestBuilder(object):

    def __init__(self) -> None:
        query_timeline_department_request = QueryTimelineDepartmentRequest()
        query_timeline_department_request.http_method = HttpMethod.POST
        query_timeline_department_request.uri = "/open-apis/corehr/v2/departments/query_timeline"
        query_timeline_department_request.token_types = {AccessTokenType.TENANT}
        self._query_timeline_department_request: QueryTimelineDepartmentRequest = query_timeline_department_request

    def user_id_type(self, user_id_type: str) -> "QueryTimelineDepartmentRequestBuilder":
        self._query_timeline_department_request.user_id_type = user_id_type
        self._query_timeline_department_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "QueryTimelineDepartmentRequestBuilder":
        self._query_timeline_department_request.department_id_type = department_id_type
        self._query_timeline_department_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self, request_body: QueryTimelineDepartmentRequestBody) -> "QueryTimelineDepartmentRequestBuilder":
        self._query_timeline_department_request.request_body = request_body
        self._query_timeline_department_request.body = request_body
        return self

    def build(self) -> QueryTimelineDepartmentRequest:
        return self._query_timeline_department_request
