# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .search_basic_info_currency_request_body import SearchBasicInfoCurrencyRequestBody


class SearchBasicInfoCurrencyRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.request_body: Optional[SearchBasicInfoCurrencyRequestBody] = None

    @staticmethod
    def builder() -> "SearchBasicInfoCurrencyRequestBuilder":
        return SearchBasicInfoCurrencyRequestBuilder()


class SearchBasicInfoCurrencyRequestBuilder(object):

    def __init__(self) -> None:
        search_basic_info_currency_request = SearchBasicInfoCurrencyRequest()
        search_basic_info_currency_request.http_method = HttpMethod.POST
        search_basic_info_currency_request.uri = "/open-apis/corehr/v2/basic_info/currencies/search"
        search_basic_info_currency_request.token_types = {AccessTokenType.TENANT}
        self._search_basic_info_currency_request: SearchBasicInfoCurrencyRequest = search_basic_info_currency_request

    def page_size(self, page_size: int) -> "SearchBasicInfoCurrencyRequestBuilder":
        self._search_basic_info_currency_request.page_size = page_size
        self._search_basic_info_currency_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "SearchBasicInfoCurrencyRequestBuilder":
        self._search_basic_info_currency_request.page_token = page_token
        self._search_basic_info_currency_request.add_query("page_token", page_token)
        return self

    def request_body(self, request_body: SearchBasicInfoCurrencyRequestBody) -> "SearchBasicInfoCurrencyRequestBuilder":
        self._search_basic_info_currency_request.request_body = request_body
        self._search_basic_info_currency_request.body = request_body
        return self

    def build(self) -> SearchBasicInfoCurrencyRequest:
        return self._search_basic_info_currency_request
