# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .search_pre_hire_request_body import SearchPreHireRequestBody


class SearchPreHireRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[SearchPreHireRequestBody] = None

    @staticmethod
    def builder() -> "SearchPreHireRequestBuilder":
        return SearchPreHireRequestBuilder()


class SearchPreHireRequestBuilder(object):

    def __init__(self) -> None:
        search_pre_hire_request = SearchPreHireRequest()
        search_pre_hire_request.http_method = HttpMethod.POST
        search_pre_hire_request.uri = "/open-apis/corehr/v2/pre_hires/search"
        search_pre_hire_request.token_types = {AccessTokenType.TENANT}
        self._search_pre_hire_request: SearchPreHireRequest = search_pre_hire_request

    def page_size(self, page_size: int) -> "SearchPreHireRequestBuilder":
        self._search_pre_hire_request.page_size = page_size
        self._search_pre_hire_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "SearchPreHireRequestBuilder":
        self._search_pre_hire_request.page_token = page_token
        self._search_pre_hire_request.add_query("page_token", page_token)
        return self

    def user_id_type(self, user_id_type: str) -> "SearchPreHireRequestBuilder":
        self._search_pre_hire_request.user_id_type = user_id_type
        self._search_pre_hire_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "SearchPreHireRequestBuilder":
        self._search_pre_hire_request.department_id_type = department_id_type
        self._search_pre_hire_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self, request_body: SearchPreHireRequestBody) -> "SearchPreHireRequestBuilder":
        self._search_pre_hire_request.request_body = request_body
        self._search_pre_hire_request.body = request_body
        return self

    def build(self) -> SearchPreHireRequest:
        return self._search_pre_hire_request
