# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .tree_department_request_body import TreeDepartmentRequestBody


class TreeDepartmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[TreeDepartmentRequestBody] = None

    @staticmethod
    def builder() -> "TreeDepartmentRequestBuilder":
        return TreeDepartmentRequestBuilder()


class TreeDepartmentRequestBuilder(object):

    def __init__(self) -> None:
        tree_department_request = TreeDepartmentRequest()
        tree_department_request.http_method = HttpMethod.POST
        tree_department_request.uri = "/open-apis/corehr/v2/departments/tree"
        tree_department_request.token_types = {AccessTokenType.TENANT}
        self._tree_department_request: TreeDepartmentRequest = tree_department_request

    def page_size(self, page_size: int) -> "TreeDepartmentRequestBuilder":
        self._tree_department_request.page_size = page_size
        self._tree_department_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "TreeDepartmentRequestBuilder":
        self._tree_department_request.page_token = page_token
        self._tree_department_request.add_query("page_token", page_token)
        return self

    def department_id_type(self, department_id_type: str) -> "TreeDepartmentRequestBuilder":
        self._tree_department_request.department_id_type = department_id_type
        self._tree_department_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self, request_body: TreeDepartmentRequestBody) -> "TreeDepartmentRequestBuilder":
        self._tree_department_request.request_body = request_body
        self._tree_department_request.body = request_body
        return self

    def build(self) -> TreeDepartmentRequest:
        return self._tree_department_request
