# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .bot_message import BotMessage


class CreateBotMessageRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[BotMessage] = None

    @staticmethod
    def builder() -> "CreateBotMessageRequestBuilder":
        return CreateBotMessageRequestBuilder()


class CreateBotMessageRequestBuilder(object):

    def __init__(self) -> None:
        create_bot_message_request = CreateBotMessageRequest()
        create_bot_message_request.http_method = HttpMethod.POST
        create_bot_message_request.uri = "/open-apis/helpdesk/v1/message"
        create_bot_message_request.token_types = {AccessTokenType.TENANT}
        self._create_bot_message_request: CreateBotMessageRequest = create_bot_message_request

    def user_id_type(self, user_id_type: str) -> "CreateBotMessageRequestBuilder":
        self._create_bot_message_request.user_id_type = user_id_type
        self._create_bot_message_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: BotMessage) -> "CreateBotMessageRequestBuilder":
        self._create_bot_message_request.request_body = request_body
        self._create_bot_message_request.body = request_body
        return self

    def build(self) -> CreateBotMessageRequest:
        return self._create_bot_message_request
