# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .batch_update_job_manager_request_body import BatchUpdateJobManagerRequestBody


class BatchUpdateJobManagerRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.job_id: Optional[str] = None
        self.request_body: Optional[BatchUpdateJobManagerRequestBody] = None

    @staticmethod
    def builder() -> "BatchUpdateJobManagerRequestBuilder":
        return BatchUpdateJobManagerRequestBuilder()


class BatchUpdateJobManagerRequestBuilder(object):

    def __init__(self) -> None:
        batch_update_job_manager_request = BatchUpdateJobManagerRequest()
        batch_update_job_manager_request.http_method = HttpMethod.POST
        batch_update_job_manager_request.uri = "/open-apis/hire/v1/jobs/:job_id/managers/batch_update"
        batch_update_job_manager_request.token_types = {AccessTokenType.TENANT}
        self._batch_update_job_manager_request: BatchUpdateJobManagerRequest = batch_update_job_manager_request

    def user_id_type(self, user_id_type: str) -> "BatchUpdateJobManagerRequestBuilder":
        self._batch_update_job_manager_request.user_id_type = user_id_type
        self._batch_update_job_manager_request.add_query("user_id_type", user_id_type)
        return self

    def job_id(self, job_id: str) -> "BatchUpdateJobManagerRequestBuilder":
        self._batch_update_job_manager_request.job_id = job_id
        self._batch_update_job_manager_request.paths["job_id"] = str(job_id)
        return self

    def request_body(self, request_body: BatchUpdateJobManagerRequestBody) -> "BatchUpdateJobManagerRequestBuilder":
        self._batch_update_job_manager_request.request_body = request_body
        self._batch_update_job_manager_request.body = request_body
        return self

    def build(self) -> BatchUpdateJobManagerRequest:
        return self._batch_update_job_manager_request
