# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class CloseJobRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.job_id: Optional[str] = None

    @staticmethod
    def builder() -> "CloseJobRequestBuilder":
        return CloseJobRequestBuilder()


class CloseJobRequestBuilder(object):

    def __init__(self) -> None:
        close_job_request = CloseJobRequest()
        close_job_request.http_method = HttpMethod.POST
        close_job_request.uri = "/open-apis/hire/v1/jobs/:job_id/close"
        close_job_request.token_types = {AccessTokenType.TENANT}
        self._close_job_request: CloseJobRequest = close_job_request

    def job_id(self, job_id: str) -> "CloseJobRequestBuilder":
        self._close_job_request.job_id = job_id
        self._close_job_request.paths["job_id"] = str(job_id)
        return self

    def build(self) -> CloseJobRequest:
        return self._close_job_request
