# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .combined_create_talent_request_body import CombinedCreateTalentRequestBody


class CombinedCreateTalentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[CombinedCreateTalentRequestBody] = None

    @staticmethod
    def builder() -> "CombinedCreateTalentRequestBuilder":
        return CombinedCreateTalentRequestBuilder()


class CombinedCreateTalentRequestBuilder(object):

    def __init__(self) -> None:
        combined_create_talent_request = CombinedCreateTalentRequest()
        combined_create_talent_request.http_method = HttpMethod.POST
        combined_create_talent_request.uri = "/open-apis/hire/v1/talents/combined_create"
        combined_create_talent_request.token_types = {AccessTokenType.TENANT}
        self._combined_create_talent_request: CombinedCreateTalentRequest = combined_create_talent_request

    def user_id_type(self, user_id_type: str) -> "CombinedCreateTalentRequestBuilder":
        self._combined_create_talent_request.user_id_type = user_id_type
        self._combined_create_talent_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: CombinedCreateTalentRequestBody) -> "CombinedCreateTalentRequestBuilder":
        self._combined_create_talent_request.request_body = request_body
        self._combined_create_talent_request.body = request_body
        return self

    def build(self) -> CombinedCreateTalentRequest:
        return self._combined_create_talent_request
