# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .external_reward import ExternalReward


class CreateExternalReferralRewardRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[ExternalReward] = None

    @staticmethod
    def builder() -> "CreateExternalReferralRewardRequestBuilder":
        return CreateExternalReferralRewardRequestBuilder()


class CreateExternalReferralRewardRequestBuilder(object):

    def __init__(self) -> None:
        create_external_referral_reward_request = CreateExternalReferralRewardRequest()
        create_external_referral_reward_request.http_method = HttpMethod.POST
        create_external_referral_reward_request.uri = "/open-apis/hire/v1/external_referral_rewards"
        create_external_referral_reward_request.token_types = {AccessTokenType.TENANT}
        self._create_external_referral_reward_request: CreateExternalReferralRewardRequest = create_external_referral_reward_request

    def user_id_type(self, user_id_type: str) -> "CreateExternalReferralRewardRequestBuilder":
        self._create_external_referral_reward_request.user_id_type = user_id_type
        self._create_external_referral_reward_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: ExternalReward) -> "CreateExternalReferralRewardRequestBuilder":
        self._create_external_referral_reward_request.request_body = request_body
        self._create_external_referral_reward_request.body = request_body
        return self

    def build(self) -> CreateExternalReferralRewardRequest:
        return self._create_external_referral_reward_request
