# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .website_user import WebsiteUser


class CreateWebsiteSiteUserRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.website_id: Optional[str] = None
        self.request_body: Optional[WebsiteUser] = None

    @staticmethod
    def builder() -> "CreateWebsiteSiteUserRequestBuilder":
        return CreateWebsiteSiteUserRequestBuilder()


class CreateWebsiteSiteUserRequestBuilder(object):

    def __init__(self) -> None:
        create_website_site_user_request = CreateWebsiteSiteUserRequest()
        create_website_site_user_request.http_method = HttpMethod.POST
        create_website_site_user_request.uri = "/open-apis/hire/v1/websites/:website_id/site_users"
        create_website_site_user_request.token_types = {AccessTokenType.TENANT}
        self._create_website_site_user_request: CreateWebsiteSiteUserRequest = create_website_site_user_request

    def website_id(self, website_id: str) -> "CreateWebsiteSiteUserRequestBuilder":
        self._create_website_site_user_request.website_id = website_id
        self._create_website_site_user_request.paths["website_id"] = str(website_id)
        return self

    def request_body(self, request_body: WebsiteUser) -> "CreateWebsiteSiteUserRequestBuilder":
        self._create_website_site_user_request.request_body = request_body
        self._create_website_site_user_request.body = request_body
        return self

    def build(self) -> CreateWebsiteSiteUserRequest:
        return self._create_website_site_user_request
