# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class DeleteNoteRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.note_id: Optional[str] = None

    @staticmethod
    def builder() -> "DeleteNoteRequestBuilder":
        return DeleteNoteRequestBuilder()


class DeleteNoteRequestBuilder(object):

    def __init__(self) -> None:
        delete_note_request = DeleteNoteRequest()
        delete_note_request.http_method = HttpMethod.DELETE
        delete_note_request.uri = "/open-apis/hire/v1/notes/:note_id"
        delete_note_request.token_types = {AccessTokenType.TENANT}
        self._delete_note_request: DeleteNoteRequest = delete_note_request

    def note_id(self, note_id: str) -> "DeleteNoteRequestBuilder":
        self._delete_note_request.note_id = note_id
        self._delete_note_request.paths["note_id"] = str(note_id)
        return self

    def build(self) -> DeleteNoteRequest:
        return self._delete_note_request
