# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class DeleteWebsiteChannelRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.website_id: Optional[str] = None
        self.channel_id: Optional[str] = None

    @staticmethod
    def builder() -> "DeleteWebsiteChannelRequestBuilder":
        return DeleteWebsiteChannelRequestBuilder()


class DeleteWebsiteChannelRequestBuilder(object):

    def __init__(self) -> None:
        delete_website_channel_request = DeleteWebsiteChannelRequest()
        delete_website_channel_request.http_method = HttpMethod.DELETE
        delete_website_channel_request.uri = "/open-apis/hire/v1/websites/:website_id/channels/:channel_id"
        delete_website_channel_request.token_types = {AccessTokenType.TENANT}
        self._delete_website_channel_request: DeleteWebsiteChannelRequest = delete_website_channel_request

    def website_id(self, website_id: str) -> "DeleteWebsiteChannelRequestBuilder":
        self._delete_website_channel_request.website_id = website_id
        self._delete_website_channel_request.paths["website_id"] = str(website_id)
        return self

    def channel_id(self, channel_id: str) -> "DeleteWebsiteChannelRequestBuilder":
        self._delete_website_channel_request.channel_id = channel_id
        self._delete_website_channel_request.paths["channel_id"] = str(channel_id)
        return self

    def build(self) -> DeleteWebsiteChannelRequest:
        return self._delete_website_channel_request
