# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetWebsiteJobPostRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.job_level_id_type: Optional[str] = None
        self.website_id: Optional[str] = None
        self.job_post_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetWebsiteJobPostRequestBuilder":
        return GetWebsiteJobPostRequestBuilder()


class GetWebsiteJobPostRequestBuilder(object):

    def __init__(self) -> None:
        get_website_job_post_request = GetWebsiteJobPostRequest()
        get_website_job_post_request.http_method = HttpMethod.GET
        get_website_job_post_request.uri = "/open-apis/hire/v1/websites/:website_id/job_posts/:job_post_id"
        get_website_job_post_request.token_types = {AccessTokenType.TENANT}
        self._get_website_job_post_request: GetWebsiteJobPostRequest = get_website_job_post_request

    def user_id_type(self, user_id_type: str) -> "GetWebsiteJobPostRequestBuilder":
        self._get_website_job_post_request.user_id_type = user_id_type
        self._get_website_job_post_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "GetWebsiteJobPostRequestBuilder":
        self._get_website_job_post_request.department_id_type = department_id_type
        self._get_website_job_post_request.add_query("department_id_type", department_id_type)
        return self

    def job_level_id_type(self, job_level_id_type: str) -> "GetWebsiteJobPostRequestBuilder":
        self._get_website_job_post_request.job_level_id_type = job_level_id_type
        self._get_website_job_post_request.add_query("job_level_id_type", job_level_id_type)
        return self

    def website_id(self, website_id: str) -> "GetWebsiteJobPostRequestBuilder":
        self._get_website_job_post_request.website_id = website_id
        self._get_website_job_post_request.paths["website_id"] = str(website_id)
        return self

    def job_post_id(self, job_post_id: str) -> "GetWebsiteJobPostRequestBuilder":
        self._get_website_job_post_request.job_post_id = job_post_id
        self._get_website_job_post_request.paths["job_post_id"] = str(job_post_id)
        return self

    def build(self) -> GetWebsiteJobPostRequest:
        return self._get_website_job_post_request
