# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListInterviewRecordRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.ids: Optional[List[str]] = None
        self.user_id_type: Optional[str] = None

    @staticmethod
    def builder() -> "ListInterviewRecordRequestBuilder":
        return ListInterviewRecordRequestBuilder()


class ListInterviewRecordRequestBuilder(object):

    def __init__(self) -> None:
        list_interview_record_request = ListInterviewRecordRequest()
        list_interview_record_request.http_method = HttpMethod.GET
        list_interview_record_request.uri = "/open-apis/hire/v1/interview_records"
        list_interview_record_request.token_types = {AccessTokenType.TENANT}
        self._list_interview_record_request: ListInterviewRecordRequest = list_interview_record_request

    def page_size(self, page_size: int) -> "ListInterviewRecordRequestBuilder":
        self._list_interview_record_request.page_size = page_size
        self._list_interview_record_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListInterviewRecordRequestBuilder":
        self._list_interview_record_request.page_token = page_token
        self._list_interview_record_request.add_query("page_token", page_token)
        return self

    def ids(self, ids: List[str]) -> "ListInterviewRecordRequestBuilder":
        self._list_interview_record_request.ids = ids
        self._list_interview_record_request.add_query("ids", ids)
        return self

    def user_id_type(self, user_id_type: str) -> "ListInterviewRecordRequestBuilder":
        self._list_interview_record_request.user_id_type = user_id_type
        self._list_interview_record_request.add_query("user_id_type", user_id_type)
        return self

    def build(self) -> ListInterviewRecordRequest:
        return self._list_interview_record_request
