# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListInterviewRegistrationSchemaRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None

    @staticmethod
    def builder() -> "ListInterviewRegistrationSchemaRequestBuilder":
        return ListInterviewRegistrationSchemaRequestBuilder()


class ListInterviewRegistrationSchemaRequestBuilder(object):

    def __init__(self) -> None:
        list_interview_registration_schema_request = ListInterviewRegistrationSchemaRequest()
        list_interview_registration_schema_request.http_method = HttpMethod.GET
        list_interview_registration_schema_request.uri = "/open-apis/hire/v1/interview_registration_schemas"
        list_interview_registration_schema_request.token_types = {AccessTokenType.TENANT}
        self._list_interview_registration_schema_request: ListInterviewRegistrationSchemaRequest = list_interview_registration_schema_request

    def page_token(self, page_token: str) -> "ListInterviewRegistrationSchemaRequestBuilder":
        self._list_interview_registration_schema_request.page_token = page_token
        self._list_interview_registration_schema_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "ListInterviewRegistrationSchemaRequestBuilder":
        self._list_interview_registration_schema_request.page_size = page_size
        self._list_interview_registration_schema_request.add_query("page_size", page_size)
        return self

    def build(self) -> ListInterviewRegistrationSchemaRequest:
        return self._list_interview_registration_schema_request
