# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListRoleRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None

    @staticmethod
    def builder() -> "ListRoleRequestBuilder":
        return ListRoleRequestBuilder()


class ListRoleRequestBuilder(object):

    def __init__(self) -> None:
        list_role_request = ListRoleRequest()
        list_role_request.http_method = HttpMethod.GET
        list_role_request.uri = "/open-apis/hire/v1/roles"
        list_role_request.token_types = {AccessTokenType.TENANT}
        self._list_role_request: ListRoleRequest = list_role_request

    def page_token(self, page_token: str) -> "ListRoleRequestBuilder":
        self._list_role_request.page_token = page_token
        self._list_role_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "ListRoleRequestBuilder":
        self._list_role_request.page_size = page_size
        self._list_role_request.add_query("page_size", page_size)
        return self

    def build(self) -> ListRoleRequest:
        return self._list_role_request
