# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListWebsiteRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None

    @staticmethod
    def builder() -> "ListWebsiteRequestBuilder":
        return ListWebsiteRequestBuilder()


class ListWebsiteRequestBuilder(object):

    def __init__(self) -> None:
        list_website_request = ListWebsiteRequest()
        list_website_request.http_method = HttpMethod.GET
        list_website_request.uri = "/open-apis/hire/v1/websites"
        list_website_request.token_types = {AccessTokenType.TENANT}
        self._list_website_request: ListWebsiteRequest = list_website_request

    def page_token(self, page_token: str) -> "ListWebsiteRequestBuilder":
        self._list_website_request.page_token = page_token
        self._list_website_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "ListWebsiteRequestBuilder":
        self._list_website_request.page_size = page_size
        self._list_website_request.add_query("page_size", page_size)
        return self

    def build(self) -> ListWebsiteRequest:
        return self._list_website_request
