# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .external_interview_assessment import ExternalInterviewAssessment


class PatchExternalInterviewAssessmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.external_interview_assessment_id: Optional[str] = None
        self.request_body: Optional[ExternalInterviewAssessment] = None

    @staticmethod
    def builder() -> "PatchExternalInterviewAssessmentRequestBuilder":
        return PatchExternalInterviewAssessmentRequestBuilder()


class PatchExternalInterviewAssessmentRequestBuilder(object):

    def __init__(self) -> None:
        patch_external_interview_assessment_request = PatchExternalInterviewAssessmentRequest()
        patch_external_interview_assessment_request.http_method = HttpMethod.PATCH
        patch_external_interview_assessment_request.uri = "/open-apis/hire/v1/external_interview_assessments/:external_interview_assessment_id"
        patch_external_interview_assessment_request.token_types = {AccessTokenType.TENANT}
        self._patch_external_interview_assessment_request: PatchExternalInterviewAssessmentRequest = patch_external_interview_assessment_request

    def external_interview_assessment_id(self,
                                         external_interview_assessment_id: str) -> "PatchExternalInterviewAssessmentRequestBuilder":
        self._patch_external_interview_assessment_request.external_interview_assessment_id = external_interview_assessment_id
        self._patch_external_interview_assessment_request.paths["external_interview_assessment_id"] = str(
            external_interview_assessment_id)
        return self

    def request_body(self,
                     request_body: ExternalInterviewAssessment) -> "PatchExternalInterviewAssessmentRequestBuilder":
        self._patch_external_interview_assessment_request.request_body = request_body
        self._patch_external_interview_assessment_request.body = request_body
        return self

    def build(self) -> PatchExternalInterviewAssessmentRequest:
        return self._patch_external_interview_assessment_request
