# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .search_referral_request_body import SearchReferralRequestBody


class SearchReferralRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[SearchReferralRequestBody] = None

    @staticmethod
    def builder() -> "SearchReferralRequestBuilder":
        return SearchReferralRequestBuilder()


class SearchReferralRequestBuilder(object):

    def __init__(self) -> None:
        search_referral_request = SearchReferralRequest()
        search_referral_request.http_method = HttpMethod.POST
        search_referral_request.uri = "/open-apis/hire/v1/referrals/search"
        search_referral_request.token_types = {AccessTokenType.TENANT}
        self._search_referral_request: SearchReferralRequest = search_referral_request

    def user_id_type(self, user_id_type: str) -> "SearchReferralRequestBuilder":
        self._search_referral_request.user_id_type = user_id_type
        self._search_referral_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: SearchReferralRequestBody) -> "SearchReferralRequestBuilder":
        self._search_referral_request.request_body = request_body
        self._search_referral_request.body = request_body
        return self

    def build(self) -> SearchReferralRequest:
        return self._search_referral_request
