# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .search_website_job_post_request_body import SearchWebsiteJobPostRequestBody


class SearchWebsiteJobPostRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.job_level_id_type: Optional[str] = None
        self.website_id: Optional[str] = None
        self.request_body: Optional[SearchWebsiteJobPostRequestBody] = None

    @staticmethod
    def builder() -> "SearchWebsiteJobPostRequestBuilder":
        return SearchWebsiteJobPostRequestBuilder()


class SearchWebsiteJobPostRequestBuilder(object):

    def __init__(self) -> None:
        search_website_job_post_request = SearchWebsiteJobPostRequest()
        search_website_job_post_request.http_method = HttpMethod.POST
        search_website_job_post_request.uri = "/open-apis/hire/v1/websites/:website_id/job_posts/search"
        search_website_job_post_request.token_types = {AccessTokenType.TENANT}
        self._search_website_job_post_request: SearchWebsiteJobPostRequest = search_website_job_post_request

    def page_token(self, page_token: str) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.page_token = page_token
        self._search_website_job_post_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.page_size = page_size
        self._search_website_job_post_request.add_query("page_size", page_size)
        return self

    def user_id_type(self, user_id_type: str) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.user_id_type = user_id_type
        self._search_website_job_post_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.department_id_type = department_id_type
        self._search_website_job_post_request.add_query("department_id_type", department_id_type)
        return self

    def job_level_id_type(self, job_level_id_type: str) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.job_level_id_type = job_level_id_type
        self._search_website_job_post_request.add_query("job_level_id_type", job_level_id_type)
        return self

    def website_id(self, website_id: str) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.website_id = website_id
        self._search_website_job_post_request.paths["website_id"] = str(website_id)
        return self

    def request_body(self, request_body: SearchWebsiteJobPostRequestBody) -> "SearchWebsiteJobPostRequestBuilder":
        self._search_website_job_post_request.request_body = request_body
        self._search_website_job_post_request.body = request_body
        return self

    def build(self) -> SearchWebsiteJobPostRequest:
        return self._search_website_job_post_request
