# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.get_by_talent_interview_request import GetByTalentInterviewRequest
from ..model.get_by_talent_interview_response import GetByTalentInterviewResponse
from ..model.list_interview_request import ListInterviewRequest
from ..model.list_interview_response import ListInterviewResponse


class Interview(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def get_by_talent(self, request: GetByTalentInterviewRequest,
                      option: Optional[RequestOption] = None) -> GetByTalentInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetByTalentInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8), GetByTalentInterviewResponse)
        response.raw = resp

        return response

    async def aget_by_talent(self, request: GetByTalentInterviewRequest,
                             option: Optional[RequestOption] = None) -> GetByTalentInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetByTalentInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8), GetByTalentInterviewResponse)
        response.raw = resp

        return response

    def list(self, request: ListInterviewRequest, option: Optional[RequestOption] = None) -> ListInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8), ListInterviewResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListInterviewRequest,
                    option: Optional[RequestOption] = None) -> ListInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8), ListInterviewResponse)
        response.raw = resp

        return response
