# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.batch_update_job_manager_request import BatchUpdateJobManagerRequest
from ..model.batch_update_job_manager_response import BatchUpdateJobManagerResponse
from ..model.get_job_manager_request import GetJobManagerRequest
from ..model.get_job_manager_response import GetJobManagerResponse


class JobManager(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_update(self, request: BatchUpdateJobManagerRequest,
                     option: Optional[RequestOption] = None) -> BatchUpdateJobManagerResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchUpdateJobManagerResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 BatchUpdateJobManagerResponse)
        response.raw = resp

        return response

    async def abatch_update(self, request: BatchUpdateJobManagerRequest,
                            option: Optional[RequestOption] = None) -> BatchUpdateJobManagerResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BatchUpdateJobManagerResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                 BatchUpdateJobManagerResponse)
        response.raw = resp

        return response

    def get(self, request: GetJobManagerRequest, option: Optional[RequestOption] = None) -> GetJobManagerResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetJobManagerResponse = JSON.unmarshal(str(resp.content, UTF_8), GetJobManagerResponse)
        response.raw = resp

        return response

    async def aget(self, request: GetJobManagerRequest,
                   option: Optional[RequestOption] = None) -> GetJobManagerResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetJobManagerResponse = JSON.unmarshal(str(resp.content, UTF_8), GetJobManagerResponse)
        response.raw = resp

        return response
