# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.create_tripartite_agreement_request import CreateTripartiteAgreementRequest
from ..model.create_tripartite_agreement_response import CreateTripartiteAgreementResponse
from ..model.delete_tripartite_agreement_request import DeleteTripartiteAgreementRequest
from ..model.delete_tripartite_agreement_response import DeleteTripartiteAgreementResponse
from ..model.list_tripartite_agreement_request import ListTripartiteAgreementRequest
from ..model.list_tripartite_agreement_response import ListTripartiteAgreementResponse
from ..model.update_tripartite_agreement_request import UpdateTripartiteAgreementRequest
from ..model.update_tripartite_agreement_response import UpdateTripartiteAgreementResponse


class TripartiteAgreement(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateTripartiteAgreementRequest,
               option: Optional[RequestOption] = None) -> CreateTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     CreateTripartiteAgreementResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateTripartiteAgreementRequest,
                      option: Optional[RequestOption] = None) -> CreateTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     CreateTripartiteAgreementResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteTripartiteAgreementRequest,
               option: Optional[RequestOption] = None) -> DeleteTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     DeleteTripartiteAgreementResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteTripartiteAgreementRequest,
                      option: Optional[RequestOption] = None) -> DeleteTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     DeleteTripartiteAgreementResponse)
        response.raw = resp

        return response

    def list(self, request: ListTripartiteAgreementRequest,
             option: Optional[RequestOption] = None) -> ListTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   ListTripartiteAgreementResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListTripartiteAgreementRequest,
                    option: Optional[RequestOption] = None) -> ListTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   ListTripartiteAgreementResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateTripartiteAgreementRequest,
               option: Optional[RequestOption] = None) -> UpdateTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     UpdateTripartiteAgreementResponse)
        response.raw = resp

        return response

    async def aupdate(self, request: UpdateTripartiteAgreementRequest,
                      option: Optional[RequestOption] = None) -> UpdateTripartiteAgreementResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: UpdateTripartiteAgreementResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                     UpdateTripartiteAgreementResponse)
        response.raw = resp

        return response
