# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.create_website_channel_request import CreateWebsiteChannelRequest
from ..model.create_website_channel_response import CreateWebsiteChannelResponse
from ..model.delete_website_channel_request import DeleteWebsiteChannelRequest
from ..model.delete_website_channel_response import DeleteWebsiteChannelResponse
from ..model.list_website_channel_request import ListWebsiteChannelRequest
from ..model.list_website_channel_response import ListWebsiteChannelResponse
from ..model.update_website_channel_request import UpdateWebsiteChannelRequest
from ..model.update_website_channel_response import UpdateWebsiteChannelResponse


class WebsiteChannel(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateWebsiteChannelRequest,
               option: Optional[RequestOption] = None) -> CreateWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateWebsiteChannelResponse)
        response.raw = resp

        return response

    async def acreate(self, request: CreateWebsiteChannelRequest,
                      option: Optional[RequestOption] = None) -> CreateWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: CreateWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateWebsiteChannelResponse)
        response.raw = resp

        return response

    def delete(self, request: DeleteWebsiteChannelRequest,
               option: Optional[RequestOption] = None) -> DeleteWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: DeleteWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteWebsiteChannelResponse)
        response.raw = resp

        return response

    async def adelete(self, request: DeleteWebsiteChannelRequest,
                      option: Optional[RequestOption] = None) -> DeleteWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: DeleteWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), DeleteWebsiteChannelResponse)
        response.raw = resp

        return response

    def list(self, request: ListWebsiteChannelRequest,
             option: Optional[RequestOption] = None) -> ListWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), ListWebsiteChannelResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListWebsiteChannelRequest,
                    option: Optional[RequestOption] = None) -> ListWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), ListWebsiteChannelResponse)
        response.raw = resp

        return response

    def update(self, request: UpdateWebsiteChannelRequest,
               option: Optional[RequestOption] = None) -> UpdateWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: UpdateWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateWebsiteChannelResponse)
        response.raw = resp

        return response

    async def aupdate(self, request: UpdateWebsiteChannelRequest,
                      option: Optional[RequestOption] = None) -> UpdateWebsiteChannelResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: UpdateWebsiteChannelResponse = JSON.unmarshal(str(resp.content, UTF_8), UpdateWebsiteChannelResponse)
        response.raw = resp

        return response
