# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.get_website_job_post_request import GetWebsiteJobPostRequest
from ..model.get_website_job_post_response import GetWebsiteJobPostResponse
from ..model.list_website_job_post_request import ListWebsiteJobPostRequest
from ..model.list_website_job_post_response import ListWebsiteJobPostResponse
from ..model.search_website_job_post_request import SearchWebsiteJobPostRequest
from ..model.search_website_job_post_response import SearchWebsiteJobPostResponse


class WebsiteJobPost(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def get(self, request: GetWebsiteJobPostRequest,
            option: Optional[RequestOption] = None) -> GetWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), GetWebsiteJobPostResponse)
        response.raw = resp

        return response

    async def aget(self, request: GetWebsiteJobPostRequest,
                   option: Optional[RequestOption] = None) -> GetWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: GetWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), GetWebsiteJobPostResponse)
        response.raw = resp

        return response

    def list(self, request: ListWebsiteJobPostRequest,
             option: Optional[RequestOption] = None) -> ListWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), ListWebsiteJobPostResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListWebsiteJobPostRequest,
                    option: Optional[RequestOption] = None) -> ListWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), ListWebsiteJobPostResponse)
        response.raw = resp

        return response

    def search(self, request: SearchWebsiteJobPostRequest,
               option: Optional[RequestOption] = None) -> SearchWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: SearchWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), SearchWebsiteJobPostResponse)
        response.raw = resp

        return response

    async def asearch(self, request: SearchWebsiteJobPostRequest,
                      option: Optional[RequestOption] = None) -> SearchWebsiteJobPostResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: SearchWebsiteJobPostResponse = JSON.unmarshal(str(resp.content, UTF_8), SearchWebsiteJobPostResponse)
        response.raw = resp

        return response
