# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .push_follow_up_message_request_body import PushFollowUpMessageRequestBody


class PushFollowUpMessageRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.message_id: Optional[str] = None
        self.request_body: Optional[PushFollowUpMessageRequestBody] = None

    @staticmethod
    def builder() -> "PushFollowUpMessageRequestBuilder":
        return PushFollowUpMessageRequestBuilder()


class PushFollowUpMessageRequestBuilder(object):

    def __init__(self) -> None:
        push_follow_up_message_request = PushFollowUpMessageRequest()
        push_follow_up_message_request.http_method = HttpMethod.POST
        push_follow_up_message_request.uri = "/open-apis/im/v1/messages/:message_id/push_follow_up"
        push_follow_up_message_request.token_types = {AccessTokenType.TENANT}
        self._push_follow_up_message_request: PushFollowUpMessageRequest = push_follow_up_message_request

    def message_id(self, message_id: str) -> "PushFollowUpMessageRequestBuilder":
        self._push_follow_up_message_request.message_id = message_id
        self._push_follow_up_message_request.paths["message_id"] = str(message_id)
        return self

    def request_body(self, request_body: PushFollowUpMessageRequestBody) -> "PushFollowUpMessageRequestBuilder":
        self._push_follow_up_message_request.request_body = request_body
        self._push_follow_up_message_request.body = request_body
        return self

    def build(self) -> PushFollowUpMessageRequest:
        return self._push_follow_up_message_request
