# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.bot_time_sentive_feed_card_request import BotTimeSentiveFeedCardRequest
from ..model.bot_time_sentive_feed_card_response import BotTimeSentiveFeedCardResponse
from ..model.patch_feed_card_request import PatchFeedCardRequest
from ..model.patch_feed_card_response import PatchFeedCardResponse


class FeedCard(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def bot_time_sentive(self, request: BotTimeSentiveFeedCardRequest,
                         option: Optional[RequestOption] = None) -> BotTimeSentiveFeedCardResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BotTimeSentiveFeedCardResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  BotTimeSentiveFeedCardResponse)
        response.raw = resp

        return response

    async def abot_time_sentive(self, request: BotTimeSentiveFeedCardRequest,
                                option: Optional[RequestOption] = None) -> BotTimeSentiveFeedCardResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: BotTimeSentiveFeedCardResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  BotTimeSentiveFeedCardResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchFeedCardRequest, option: Optional[RequestOption] = None) -> PatchFeedCardResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchFeedCardResponse = JSON.unmarshal(str(resp.content, UTF_8), PatchFeedCardResponse)
        response.raw = resp

        return response

    async def apatch(self, request: PatchFeedCardRequest,
                     option: Optional[RequestOption] = None) -> PatchFeedCardResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: PatchFeedCardResponse = JSON.unmarshal(str(resp.content, UTF_8), PatchFeedCardResponse)
        response.raw = resp

        return response
