# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetMailgroupMemberRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.mailgroup_id: Optional[str] = None
        self.member_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetMailgroupMemberRequestBuilder":
        return GetMailgroupMemberRequestBuilder()


class GetMailgroupMemberRequestBuilder(object):

    def __init__(self) -> None:
        get_mailgroup_member_request = GetMailgroupMemberRequest()
        get_mailgroup_member_request.http_method = HttpMethod.GET
        get_mailgroup_member_request.uri = "/open-apis/mail/v1/mailgroups/:mailgroup_id/members/:member_id"
        get_mailgroup_member_request.token_types = {AccessTokenType.TENANT}
        self._get_mailgroup_member_request: GetMailgroupMemberRequest = get_mailgroup_member_request

    def user_id_type(self, user_id_type: str) -> "GetMailgroupMemberRequestBuilder":
        self._get_mailgroup_member_request.user_id_type = user_id_type
        self._get_mailgroup_member_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "GetMailgroupMemberRequestBuilder":
        self._get_mailgroup_member_request.department_id_type = department_id_type
        self._get_mailgroup_member_request.add_query("department_id_type", department_id_type)
        return self

    def mailgroup_id(self, mailgroup_id: str) -> "GetMailgroupMemberRequestBuilder":
        self._get_mailgroup_member_request.mailgroup_id = mailgroup_id
        self._get_mailgroup_member_request.paths["mailgroup_id"] = str(mailgroup_id)
        return self

    def member_id(self, member_id: str) -> "GetMailgroupMemberRequestBuilder":
        self._get_mailgroup_member_request.member_id = member_id
        self._get_mailgroup_member_request.paths["member_id"] = str(member_id)
        return self

    def build(self) -> GetMailgroupMemberRequest:
        return self._get_mailgroup_member_request
