# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetTaskCommentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.task_id: Optional[str] = None
        self.comment_id: Optional[int] = None

    @staticmethod
    def builder() -> "GetTaskCommentRequestBuilder":
        return GetTaskCommentRequestBuilder()


class GetTaskCommentRequestBuilder(object):

    def __init__(self) -> None:
        get_task_comment_request = GetTaskCommentRequest()
        get_task_comment_request.http_method = HttpMethod.GET
        get_task_comment_request.uri = "/open-apis/task/v1/tasks/:task_id/comments/:comment_id"
        get_task_comment_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._get_task_comment_request: GetTaskCommentRequest = get_task_comment_request

    def user_id_type(self, user_id_type: str) -> "GetTaskCommentRequestBuilder":
        self._get_task_comment_request.user_id_type = user_id_type
        self._get_task_comment_request.add_query("user_id_type", user_id_type)
        return self

    def task_id(self, task_id: str) -> "GetTaskCommentRequestBuilder":
        self._get_task_comment_request.task_id = task_id
        self._get_task_comment_request.paths["task_id"] = str(task_id)
        return self

    def comment_id(self, comment_id: int) -> "GetTaskCommentRequestBuilder":
        self._get_task_comment_request.comment_id = comment_id
        self._get_task_comment_request.paths["comment_id"] = str(comment_id)
        return self

    def build(self) -> GetTaskCommentRequest:
        return self._get_task_comment_request
