# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListTaskCommentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.list_direction: Optional[int] = None
        self.user_id_type: Optional[str] = None
        self.task_id: Optional[str] = None

    @staticmethod
    def builder() -> "ListTaskCommentRequestBuilder":
        return ListTaskCommentRequestBuilder()


class ListTaskCommentRequestBuilder(object):

    def __init__(self) -> None:
        list_task_comment_request = ListTaskCommentRequest()
        list_task_comment_request.http_method = HttpMethod.GET
        list_task_comment_request.uri = "/open-apis/task/v1/tasks/:task_id/comments"
        list_task_comment_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._list_task_comment_request: ListTaskCommentRequest = list_task_comment_request

    def page_size(self, page_size: int) -> "ListTaskCommentRequestBuilder":
        self._list_task_comment_request.page_size = page_size
        self._list_task_comment_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListTaskCommentRequestBuilder":
        self._list_task_comment_request.page_token = page_token
        self._list_task_comment_request.add_query("page_token", page_token)
        return self

    def list_direction(self, list_direction: int) -> "ListTaskCommentRequestBuilder":
        self._list_task_comment_request.list_direction = list_direction
        self._list_task_comment_request.add_query("list_direction", list_direction)
        return self

    def user_id_type(self, user_id_type: str) -> "ListTaskCommentRequestBuilder":
        self._list_task_comment_request.user_id_type = user_id_type
        self._list_task_comment_request.add_query("user_id_type", user_id_type)
        return self

    def task_id(self, task_id: str) -> "ListTaskCommentRequestBuilder":
        self._list_task_comment_request.task_id = task_id
        self._list_task_comment_request.paths["task_id"] = str(task_id)
        return self

    def build(self) -> ListTaskCommentRequest:
        return self._list_task_comment_request
