# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .tasklist_activity_subscription import TasklistActivitySubscription


class CreateTasklistActivitySubscriptionRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.tasklist_guid: Optional[str] = None
        self.request_body: Optional[TasklistActivitySubscription] = None

    @staticmethod
    def builder() -> "CreateTasklistActivitySubscriptionRequestBuilder":
        return CreateTasklistActivitySubscriptionRequestBuilder()


class CreateTasklistActivitySubscriptionRequestBuilder(object):

    def __init__(self) -> None:
        create_tasklist_activity_subscription_request = CreateTasklistActivitySubscriptionRequest()
        create_tasklist_activity_subscription_request.http_method = HttpMethod.POST
        create_tasklist_activity_subscription_request.uri = "/open-apis/task/v2/tasklists/:tasklist_guid/activity_subscriptions"
        create_tasklist_activity_subscription_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._create_tasklist_activity_subscription_request: CreateTasklistActivitySubscriptionRequest = create_tasklist_activity_subscription_request

    def user_id_type(self, user_id_type: str) -> "CreateTasklistActivitySubscriptionRequestBuilder":
        self._create_tasklist_activity_subscription_request.user_id_type = user_id_type
        self._create_tasklist_activity_subscription_request.add_query("user_id_type", user_id_type)
        return self

    def tasklist_guid(self, tasklist_guid: str) -> "CreateTasklistActivitySubscriptionRequestBuilder":
        self._create_tasklist_activity_subscription_request.tasklist_guid = tasklist_guid
        self._create_tasklist_activity_subscription_request.paths["tasklist_guid"] = str(tasklist_guid)
        return self

    def request_body(self,
                     request_body: TasklistActivitySubscription) -> "CreateTasklistActivitySubscriptionRequestBuilder":
        self._create_tasklist_activity_subscription_request.request_body = request_body
        self._create_tasklist_activity_subscription_request.body = request_body
        return self

    def build(self) -> CreateTasklistActivitySubscriptionRequest:
        return self._create_tasklist_activity_subscription_request
