# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .patch_task_request_body import PatchTaskRequestBody


class PatchTaskRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.task_guid: Optional[str] = None
        self.request_body: Optional[PatchTaskRequestBody] = None

    @staticmethod
    def builder() -> "PatchTaskRequestBuilder":
        return PatchTaskRequestBuilder()


class PatchTaskRequestBuilder(object):

    def __init__(self) -> None:
        patch_task_request = PatchTaskRequest()
        patch_task_request.http_method = HttpMethod.PATCH
        patch_task_request.uri = "/open-apis/task/v2/tasks/:task_guid"
        patch_task_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._patch_task_request: PatchTaskRequest = patch_task_request

    def user_id_type(self, user_id_type: str) -> "PatchTaskRequestBuilder":
        self._patch_task_request.user_id_type = user_id_type
        self._patch_task_request.add_query("user_id_type", user_id_type)
        return self

    def task_guid(self, task_guid: str) -> "PatchTaskRequestBuilder":
        self._patch_task_request.task_guid = task_guid
        self._patch_task_request.paths["task_guid"] = str(task_guid)
        return self

    def request_body(self, request_body: PatchTaskRequestBody) -> "PatchTaskRequestBuilder":
        self._patch_task_request.request_body = request_body
        self._patch_task_request.body = request_body
        return self

    def build(self) -> PatchTaskRequest:
        return self._patch_task_request
