# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .remove_tasklist_task_request_body import RemoveTasklistTaskRequestBody


class RemoveTasklistTaskRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.task_guid: Optional[str] = None
        self.request_body: Optional[RemoveTasklistTaskRequestBody] = None

    @staticmethod
    def builder() -> "RemoveTasklistTaskRequestBuilder":
        return RemoveTasklistTaskRequestBuilder()


class RemoveTasklistTaskRequestBuilder(object):

    def __init__(self) -> None:
        remove_tasklist_task_request = RemoveTasklistTaskRequest()
        remove_tasklist_task_request.http_method = HttpMethod.POST
        remove_tasklist_task_request.uri = "/open-apis/task/v2/tasks/:task_guid/remove_tasklist"
        remove_tasklist_task_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._remove_tasklist_task_request: RemoveTasklistTaskRequest = remove_tasklist_task_request

    def user_id_type(self, user_id_type: str) -> "RemoveTasklistTaskRequestBuilder":
        self._remove_tasklist_task_request.user_id_type = user_id_type
        self._remove_tasklist_task_request.add_query("user_id_type", user_id_type)
        return self

    def task_guid(self, task_guid: str) -> "RemoveTasklistTaskRequestBuilder":
        self._remove_tasklist_task_request.task_guid = task_guid
        self._remove_tasklist_task_request.paths["task_guid"] = str(task_guid)
        return self

    def request_body(self, request_body: RemoveTasklistTaskRequestBody) -> "RemoveTasklistTaskRequestBuilder":
        self._remove_tasklist_task_request.request_body = request_body
        self._remove_tasklist_task_request.body = request_body
        return self

    def build(self) -> RemoveTasklistTaskRequest:
        return self._remove_tasklist_task_request
