# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class GetReserveConfigDisableInformRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.scope_type: Optional[int] = None
        self.user_id_type: Optional[str] = None
        self.reserve_config_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetReserveConfigDisableInformRequestBuilder":
        return GetReserveConfigDisableInformRequestBuilder()


class GetReserveConfigDisableInformRequestBuilder(object):

    def __init__(self) -> None:
        get_reserve_config_disable_inform_request = GetReserveConfigDisableInformRequest()
        get_reserve_config_disable_inform_request.http_method = HttpMethod.GET
        get_reserve_config_disable_inform_request.uri = "/open-apis/vc/v1/reserve_configs/:reserve_config_id/disable_inform"
        get_reserve_config_disable_inform_request.token_types = {AccessTokenType.TENANT}
        self._get_reserve_config_disable_inform_request: GetReserveConfigDisableInformRequest = get_reserve_config_disable_inform_request

    def scope_type(self, scope_type: int) -> "GetReserveConfigDisableInformRequestBuilder":
        self._get_reserve_config_disable_inform_request.scope_type = scope_type
        self._get_reserve_config_disable_inform_request.add_query("scope_type", scope_type)
        return self

    def user_id_type(self, user_id_type: str) -> "GetReserveConfigDisableInformRequestBuilder":
        self._get_reserve_config_disable_inform_request.user_id_type = user_id_type
        self._get_reserve_config_disable_inform_request.add_query("user_id_type", user_id_type)
        return self

    def reserve_config_id(self, reserve_config_id: str) -> "GetReserveConfigDisableInformRequestBuilder":
        self._get_reserve_config_disable_inform_request.reserve_config_id = reserve_config_id
        self._get_reserve_config_disable_inform_request.paths["reserve_config_id"] = str(reserve_config_id)
        return self

    def build(self) -> GetReserveConfigDisableInformRequest:
        return self._get_reserve_config_disable_inform_request
