# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .participant_quality_list_export_request_body import ParticipantQualityListExportRequestBody


class ParticipantQualityListExportRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[ParticipantQualityListExportRequestBody] = None

    @staticmethod
    def builder() -> "ParticipantQualityListExportRequestBuilder":
        return ParticipantQualityListExportRequestBuilder()


class ParticipantQualityListExportRequestBuilder(object):

    def __init__(self) -> None:
        participant_quality_list_export_request = ParticipantQualityListExportRequest()
        participant_quality_list_export_request.http_method = HttpMethod.POST
        participant_quality_list_export_request.uri = "/open-apis/vc/v1/exports/participant_quality_list"
        participant_quality_list_export_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._participant_quality_list_export_request: ParticipantQualityListExportRequest = participant_quality_list_export_request

    def user_id_type(self, user_id_type: str) -> "ParticipantQualityListExportRequestBuilder":
        self._participant_quality_list_export_request.user_id_type = user_id_type
        self._participant_quality_list_export_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self,
                     request_body: ParticipantQualityListExportRequestBody) -> "ParticipantQualityListExportRequestBuilder":
        self._participant_quality_list_export_request.request_body = request_body
        self._participant_quality_list_export_request.body = request_body
        return self

    def build(self) -> ParticipantQualityListExportRequest:
        return self._participant_quality_list_export_request
